var NAVTREE =
[
  [ "RTI Connext DDS Micro", "index.html", [
    [ "Product Overview", "product_overview.html", [
      [ "What Is RTI Connext DDS Micro?", "product_overview.html#product_overview_intro", [
        [ "RTI Connext DDS Cert versus RTI Connext DDS Micro", "product_overview.html#overview_cert", null ],
        [ "Optional Certification Package", "product_overview.html#overview_cert_cdp", null ],
        [ "Publish-Subscribe Middleware", "product_overview.html#overview_intro_ps", null ],
        [ "Other Connext Products", "product_overview.html#overview_intro_other", null ]
      ] ],
      [ "Supported DDS Features", "product_overview.html#overview_features", [
        [ "DDS Entity Support", "product_overview.html#overview_features_dds_ent", null ],
        [ "DDS QoS Policy Support", "product_overview.html#overview_supported_qos", null ]
      ] ],
      [ "Programming Languages Support", "product_overview.html#overview_langs", null ],
      [ "RTI Supported Platforms", "product_overview.html#overview_platforms", [
        [ "Linux Supported Platform", "product_overview.html#rl_platform_linux", null ],
        [ "Windows Supported Platforms", "product_overview.html#rl_platform_windows", null ],
        [ "VxWorks Supported Platforms", "product_overview.html#rl_platform_vxworks", null ],
        [ "Android Supported Platforms", "product_overview.html#rl_platform_android", null ],
        [ "iOS Supported Platforms", "product_overview.html#rl_platform_ios", null ]
      ] ],
      [ "Buildable Source", "product_overview.html#overview_build_src", null ],
      [ "Standards and Interoperability", "product_overview.html#overview_stds", [
        [ "DDS Wire Compatability", "product_overview.html#overview_stds_rtps", null ],
        [ "Qos Policy Support", "product_overview.html#overview_stds_qos", null ],
        [ "DDS API Support", "product_overview.html#overview_stds_api", null ]
      ] ]
    ] ],
    [ "Getting Started", "getting_started.html", [
      [ "Install RTI Connext DDS Micro", "getting_started.html#gs_install", [
        [ "Installing on a Windows System", "getting_started.html#rl_install_windows", null ],
        [ "Installing on a UNIX-Based System", "getting_started.html#rl_install_unix", null ],
        [ "Unpacking Buildable Source", "getting_started.html#rl_install_source", null ],
        [ "Environment", "getting_started.html#rl_install_env", null ]
      ] ],
      [ "Define a Data Type", "getting_started.html#gs_typegen", null ],
      [ "Generate Type Support Code with rtiddsgen", "getting_started.html#gs_rtiddsgen", null ],
      [ "Create an Application", "getting_started.html#gs_create_app", [
        [ "Registry Configuration", "getting_started.html#gs_registry", null ]
      ] ],
      [ "Configuring UDP Transport", "getting_started.html#gs_udp", null ],
      [ "Create DomainParticipant, Topic, and Type", "getting_started.html#gs_participant", [
        [ "Register Type", "getting_started.html#gs_participant_type", null ],
        [ "Create Topic of Registered Type", "getting_started.html#gs_participant_topic", null ],
        [ "DPSE Discovery: Assert Remote Participant", "getting_started.html#gs_participant_dpse", null ]
      ] ],
      [ "Create Publisher", "getting_started.html#gs_pub", null ],
      [ "Create DataWriter", "getting_started.html#gs_writer", [
        [ "DPSE Discovery: Assert Remote Subscription", "getting_started.html#gs_writer_dpse", null ],
        [ "Writing Samples", "getting_started.html#gs_writer_write", null ]
      ] ],
      [ "Create Subscriber", "getting_started.html#gs_sub", null ],
      [ "Create DataReader", "getting_started.html#gs_reader", [
        [ "DPSE Discovery: Assert Remote Publication", "getting_started.html#gs_reader_dpse", null ],
        [ "Receiving Samples", "getting_started.html#gs_reader_receive", null ],
        [ "Filtering Samples", "getting_started.html#gs_reader_filter", null ]
      ] ]
    ] ],
    [ "Introduction to DDS", "new_to_dds.html", [
      [ "RTI Connext DDS Documentation", "new_to_dds.html#rti_doc_intro", null ],
      [ "OMG DDS Specification", "new_to_dds.html#omg_dds_spec", null ]
    ] ],
    [ "Examples", "example_code.html", null ],
    [ "Release Notes", "rl_main.html", [
      [ "2.4.8", "rl_main.html#rl_248", [
        [ "What's New", "rl_main.html#rl_new_248", null ],
        [ "What's Fixed", "rl_main.html#rl_fixed_248", [
          [ "Consistent support for assignment operator in C++", "rl_main.html#rl_new_247_1541", null ],
          [ "DPSE API renamed to avoid conflict with assert()", "rl_main.html#rl_new_247_1539", null ]
        ] ]
      ] ],
      [ "2.4.7", "rl_main.html#rl_247", [
        [ "What's New", "rl_main.html#rl_new_247", null ],
        [ "What's Fixed", "rl_main.html#rl_fixed_247", [
          [ "Statuses are passed as pointers instead of references to DDSDomainParticipantListeners", "rl_main.html#rl_new_247_1524", null ],
          [ "Missing assignment operator = in RT_ComponentFactoryId", "rl_main.html#rl_new_247_1525", null ],
          [ "CMAKE_C_FLAGS_ORIGINAL in CMakeLists.txt misspelled", "rl_main.html#rl_new_247_1526", null ],
          [ "Missing const qualifier for the sequence [] operator", "rl_main.html#rl_new_247_1527", null ],
          [ "Missing primitive IDL sequences in C++", "rl_main.html#rl_new_247_1529", null ]
        ] ]
      ] ],
      [ "2.4.6", "rl_main.html#rl_246", [
        [ "What's New", "rl_main.html#rl_new_246", [
          [ "Important API Changes", "rl_main.html#rl_new_246_API", null ],
          [ "Run-time Memory Footprint Has Been Significantly Reduced", "rl_main.html#rl_new_246_MICRO-1505", null ],
          [ "New FooTypeSupport operations", "rl_main.html#rl_new_246_MICRO-1178", null ],
          [ "All public C API now natively available to C++ users", "rl_main.html#rl_new_246_MICRO-1512", null ],
          [ "Status data passed by reference to C++ listeners", "rl_main.html#rl_new_246_MICRO-1514", null ],
          [ "TheParticipantFactory now available to C++ users", "rl_main.html#rl_new_246_MICRO-1518", null ],
          [ "Status types now available in DDS:: C++ namespace", "rl_main.html#rl_new_246_MICRO-1515", null ],
          [ "Foo::copy_data() takes const argument", "rl_main.html#rl_new_246_MICRO-1228", null ],
          [ "ConditionSeq added to C++ DDS namespace", "rl_main.html#rl_new_246_MICRO-1229", null ],
          [ "First 2-Bytes Of GUID Assigned to Vendor ID", "rl_main.html#rl_new_246_MICRO-1490", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_246", [
          [ "POSIX Threads Were Created Without Names", "rl_main.html#rl_fixed_246_MICRO-638", null ],
          [ "Prerequisite for HelloWorld_android updated in README.txt", "rl_main.html#rl_fixed_246_MICRO-807", null ],
          [ "CPP/HelloWorld_dpde example does not overwrite RTIMEHOME", "rl_main.html#rl_fixed_246_MICRO-834", null ],
          [ "Transport Not Supporting Multicast Did Not Ignore Multicast", "rl_main.html#rl_fixed_246_MICRO-1153", null ],
          [ "Discovery Messages Incorrectly Dropped When Containing Non-Standard Locators", "rl_main.html#rl_fixed_246_MICRO-1270", null ],
          [ "HEARTBEAT Not Sent in Response To Initial ACKNACK", "rl_main.html#rl_fixed_246_MICRO-1443", null ],
          [ "Incorrect Return Code From DataReader's Read or Take APIs When Max_Outstanding_Reads Exceeded", "rl_main.html#rl_fixed_246_MICRO-1460", null ],
          [ "DataReader Did Not Replace Historical Samples When max_samples_per_instance Equaled History Depth", "rl_main.html#rl_fixed_246_MICRO-1463", null ],
          [ "A Disposed Instance Could Be Updated By A DataWriter That Is Not Its Exclusive Owner", "rl_main.html#rl_fixed_246_MICRO-1464", null ],
          [ "Fixed code generation for user-defined enum constants.", "rl_main.html#rl_fixed_246_MICRO-1483", null ],
          [ "Hostname is verified as specified in RFC-952 and RFC-1123", "rl_main.html#rl_fixed_246_MICRO-1489", null ],
          [ "DDS_<Foo>Seq APIs Were Missing", "rl_main.html#rl_fixed_246_MICRO-1493", null ],
          [ "DataReader Could Reject All Subsequent Samples From a DataWriter", "rl_main.html#rl_fixed_246_MICRO-1500", null ],
          [ "POSIX Thread Priorities Not Changeable", "rl_main.html#rl_fixed_246_MICRO-1502", null ],
          [ "RTPS DATA Submessages with K-flag Set Were Dropped", "rl_main.html#rl_fixed_246_MICRO-1511", null ]
        ] ]
      ] ],
      [ "2.4.5", "rl_main.html#rl_245cert", [
        [ "Supported Architecture", "rl_main.html#rl_245cert_support", null ],
        [ "What's New", "rl_main.html#rl_new_245", [
          [ "Updated Signatures for OSAPI Functions", "rl_main.html#rl_new_245_osapi", null ],
          [ "Updated Generated Code from rtiddsgen", "rl_main.html#rl_new_245_rtiddsgen", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_245", [
          [ "Deadline Missed Status Not Triggered", "rl_main.html#rl_fixed_245_MICRO-1426", null ],
          [ "Failure in DataWriter Operations May Have Blocked Application", "rl_main.html#rl_fixed_245_MICRO-1284", null ],
          [ "Instance Handle Could Not Be Retrieved For a Topic", "rl_main.html#rl_fixed_245_MICRO-1215", null ],
          [ "Reliable DataWriter Sent Redundant Repair Samples", "rl_main.html#rl_fixed_245_MICRO-1197", null ],
          [ "Duration Based Qos Policies Where Limited to 24 Days", "rl_main.html#rl_fixed_245_MICRO-1176", null ]
        ] ]
      ] ],
      [ "2.4.4", "rl_main.html#rl_244", [
        [ "What's New", "rl_main.html#rl_new_244", [
          [ "Updated Generated Code from rtiddsgen", "rl_main.html#rl_new_244_rtiddsgen", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_244", [
          [ "Missing Parameter in Sample Filtering Callback of HelloWorld Example Resulted in Incorrectly Unfiltered Samples", "rl_main.html#rl_fixed_244_MICRO-1177", null ],
          [ "Communication With Endpoint Incorrectly Stopped After Shutdown of Other Endpoint", "rl_main.html#rl_fixed_244_MICRO-1114", null ],
          [ "Double Free by C++ Foo Sequence Functions", "rl_main.html#rl_fixed_244_MICRO-1133", null ],
          [ "Entity Name's Maximum Length Was Not 255 Bytes", "rl_main.html#rl_fixed_244_MICRO-1129", null ],
          [ "Re-discovery of Participants May Fail", "rl_main.html#rl_fixed_244_MICRO-1134", null ],
          [ "Accessing Samples with read() Resulted in New Samples Being Rejected", "rl_main.html#rl_fixed_244_MICRO-1089", null ],
          [ "Default Value of DDS_LivelinessQosPolicy Kind Was DDS_MANUAL_BY_TOPIC_LIVELINESS_QOS", "rl_main.html#rl_fixed_244_MICRO-1061", null ]
        ] ]
      ] ],
      [ "2.4.3", "rl_main.html#rl_243", [
        [ "What's New", "rl_main.html#rl_new_243", [
          [ "FACE Conformance", "rl_main.html#rl_new_243_FACE", null ]
        ] ]
      ] ],
      [ "2.4.2", "rl_main.html#rl_242", [
        [ "New Features", "rl_main.html#rl_new_242", [
          [ "Configurable Discovery of Unknown Peers", "rl_main.html#rl_new_242_1", null ]
        ] ]
      ] ],
      [ "2.4.1", "rl_main.html#rl_241", [
        [ "New Features", "rl_main.html#rl_new_241", [
          [ "New -micro option for rtiddsgen", "rl_main.html#rl_new_241_1", null ],
          [ "New language options for generating code for RTI Connext DDS Micro using rtiddsgen", "rl_main.html#rl_new_241_2", null ],
          [ "CMake Configuration for Buildable Source", "rl_main.html#rl_new_241_3", null ],
          [ "DDS_WaitSet and DDS_Condition APIs For C++", "rl_main.html#rl_new_241_4", null ],
          [ "New HelloWorld_dpde_waitset Example", "rl_main.html#rl_new_241_5", null ],
          [ "Access to Status of DDS Entities by C++ APIs", "rl_main.html#rl_new_241_6", null ],
          [ "Improved support for listeners of DDS entities in C++ API", "rl_main.html#rl_new_241_7", null ],
          [ "New Operations FooTypeSupport_register/unregister_type for User Data-Types", "rl_main.html#rl_new_241_8", null ],
          [ "Sample Info Provided With DataReaderListener's Sample Filter Callback", "rl_main.html#rl_new_241_9", null ],
          [ "More Information Provided in DDS_SampleLostStatus Type", "rl_main.html#rl_new_241_10", null ]
        ] ],
        [ "What's Fixed", "rl_main.html#rl_fixed_241", [
          [ "Full Support of -namespace Option for rtiddsgen", "rl_main.html#rl_fixed_241_1", null ],
          [ "Redundant Code Not Generated for Non Top-Level Types", "rl_main.html#rl_fixed_241_2", null ],
          [ "Setting Real-Time Clock for VxWorks Platform", "rl_main.html#rl_fixed_241_3", null ],
          [ "IDL Copy Directives Now Supported by rtiddsgen", "rl_main.html#rl_fixed_241_4", null ],
          [ "Incompatible Encoding of DDS_Duration_t with RTI Connext DDS", "rl_main.html#rl_fixed_241_5", null ],
          [ "Premature Wakeup from Semaphore Take for POSIX Platforms", "rl_main.html#rl_fixed_241_6", null ],
          [ "Failed Compilation of C++ Generated Code from rtiddsgen", "rl_main.html#rl_fixed_241_7", null ],
          [ "DDS_Topic_get_inconsistent_topic_status in C API", "rl_main.html#rl_fixed_241_8", null ],
          [ "DDS_StatusCondition's Trigger Value Not Updated When DDS_DATA_AVAILABLE_STATUS Is Reset", "rl_main.html#rl_fixed_241_9", null ],
          [ "DDS_WaitSet_get_conditions Supported by C API", "rl_main.html#rl_fixed_241_10", null ],
          [ "Reliable, Keep-Last DataReader May Stop Receiving Samples", "rl_main.html#rl_fixed_241_11", null ],
          [ "Memory Dynamically Allocated By DPSE After Initialization", "rl_main.html#rl_fixed_241_12", null ],
          [ "Application Crashed When Looking Up DomainParticipant", "rl_main.html#rl_fixed_241_13", null ],
          [ "Setting Log Verbosity May Have Been Ineffective", "rl_main.html#rl_fixed_241_14", null ],
          [ "Waitset’s Wait may have Incorrectly Timed Out when Listener also Installed", "rl_main.html#rl_fixed_241_15", null ],
          [ "Data not Received due to Samples not being Sent by all Transports", "rl_main.html#rl_fixed_241_16", null ],
          [ "Static Endpoint Discovery Restrictively Required Unique Object IDs Across All Remote Endpoints", "rl_main.html#rl_fixed_241_17", null ],
          [ "Possible Non-Discovery or Non-Communication between Connext Micro using DPSE and a Non-Micro Application", "rl_main.html#rl_fixed_241_18", null ]
        ] ]
      ] ],
      [ "Known Issues", "rl_main.html#rl_known_246", [
        [ "Incomplete Documentation for non-DDS APIs", "rl_main.html#rl_known_246_1", null ],
        [ "C++ APIs Not Supported for Android Platform", "rl_main.html#rl_known_246_2", null ],
        [ "Waitset Delete Not Safe For Concurrent Use", "rl_main.html#rl_known_246_3", null ],
        [ "Partial support of DDS_InstanceHandle_t in C++ API", "rl_main.html#rl_known_246_4", null ]
      ] ]
    ] ],
    [ "Manuals", "modules.html", "modules" ]
  ] ]
];

var NAVTREEINDEX =
[
"example_code.html",
"group__DDSCLogCodesClass.html#gaa99fc1fd6763af9d976a57838c98d7e1",
"group__DDSEntityModule.html#ga928b59d917d674720975f0581149b905",
"group__DDSStatusTypesModule.html#ggaa99b5585ecdf8c5f93ac3108439ad26fa126ff1b38cdfc905353cb2dac57b6796",
"group__DPDELogCodesClass.html#gad0d9e3f495328dfef806d56700fc1750",
"group__OSAPITimeClass.html#ga58443b5f5ec32ed3ce0de3937dbcf9f0",
"group__RTPSLogCodesClass.html#gab8b66a3721ce3982c76f27a496d891cf",
];

var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode) {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  imgNode.width = 16;
  imgNode.height = 22;
  if (level==0 && node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast) {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        } else {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  } else {
    domNode.appendChild(imgNode);
  }
  if (level==0) {
    if (node.isLast) {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    } else {
      if (node.childrenData) {
        imgNode.src = node.relpath+"ftv2pnode.png";
      } else {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  } else {
    if (node.isLast) {
      imgNode.src = node.relpath+"ftv2blank.png";
    } else {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : '#';
      a.onclick = function(){
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var pos, anchor = $(aname), docContent = $('#doc-content');
        if (anchor.parent().attr('class')=='memItemLeft') {
          pos = anchor.parent().position().top;
        } else if (anchor.position()) {
          pos = anchor.position().top;
        }
        if (pos) {
          var dist = Math.abs(Math.min(
                     pos-docContent.offset().top,
                     docContent[0].scrollHeight-
                     docContent.height()-docContent.scrollTop()));
          docContent.animate({
            scrollTop: pos + docContent.scrollTop() - docContent.offset().top
          },Math.max(50,Math.min(500,dist)),function(){
            window.location.replace(aname);
          });
        }
      };
    } else {
      a.href = url;
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var anchor = $($(location).attr('hash'));
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
}

function selectAndHighlight(n)
{
  var a;
  if ($(location).attr('hash')) {
    var link=stripPath($(location).attr('pathname'))+':'+
      $(location).attr('hash').substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  showRoot();
}

function showNode(o, node, index)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index); // retry with child node expanded
          },true);
        } else {
          var rootBase = o.toroot.replace(/\..+$/, '');
          if (rootBase=="index" || rootBase=="pages") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(n);
        }
      }
    }
  } else {
    selectAndHighlight();
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = nti ? nti : navTreeSubIndices[subIndex][root];
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0);
  }
}

function navTo(o,root,hash,relpath)
{
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     }
  })

  $(window).load(showRoot);
}

